<template>
  <div class="dashboard-editor-container">
    <el-row type="flex" align="middle" class="header-filter">
      <el-col :span="12">
        <h2>Data Intermediasi</h2>
      </el-col>
      <el-col :span="12">
        <a v-on:click="openFilter()" class="link-right">
          <span>{{ isOpen ? "Tutup" : "Buka" }} Filter</span>
          <svg-icon icon-class="filter" class="bigger" />
        </a>
      </el-col>
    </el-row>
    <transition name="fade">
      <filter-component @updateParams="updateParams" v-show="this.isOpen" />
    </transition>
    <el-row :gutter="32">
      <el-col :xs="24" :sm="24" :lg="16">
        <el-row :gutter="32">
          <el-col :xs="24" :sm="24" :lg="24">
            <div class="chart-wrapper">
              <h3 class="--green">Lokasi Intermediasi</h3>
              <hr />
              <farmer-status />
            </div>
          </el-col>
        </el-row>
      </el-col>
      <el-col :xs="24" :sm="24" :lg="8">
        <div class="chart-wrapper">
          <h3 class="--green">Jenis Kelamin</h3>
          <hr class="overflow"/>
          <gender-list />
        </div>
      </el-col>
    </el-row>
    <div class="chart-wrapper --auto">
      <h3 class="--green">Lembaga Intermediasi</h3>
      <hr />
      <institution />
    </div>
  </div>
</template>

<script>
import FilterComponent from './components/FilterComponent';
import GenderList from './components/GenderList';
import FarmerStatus from './components/FarmerStatus';
import Institution from './components/Institution';

export default {
  name: 'DashboardAdmin',
  components: {
    FilterComponent,
    GenderList,
    FarmerStatus,
    Institution
  },
  data() {
    return {
      isOpen: false
    };
  },
  created() {
    this.getData();
  },
  computed: {
    farmers: {
      get: function() {
        return this.$store.state.farmer.farmers;
      }
    }
  },
  methods: {
    openFilter() {
      this.isOpen = !this.isOpen;
    },
    updateParams(params) {
      this.openFilter();
      this.params = {
        gender: params.gender,
        id_city: params.city.join(),
        commodity: params.commodity.join(),
        status_id: params.status,
        qFrom: params.dateStart,
        qTo: params.dateEnd
      };
      this.getData();
    },
    getData() {
      this.$store.dispatch('totalRegisteredFarmer', this.params);
      this.$store.dispatch('totalFarmerhasField', this.params);
      this.$store.dispatch('totalFarmerhasCommodity', this.params);
      this.$store.dispatch('totalActiveFarmer', this.params);
      this.$store.dispatch('getFarmerByGender', this.params);
      this.$store.dispatch('getAllCommodity', this.params);
      this.$store.dispatch('getAllField', this.params);
      this.$store.dispatch('getFarmerByStatus', this.params);
      this.$store.dispatch('getCommodityPlant', this.params);
      this.$store.dispatch('countFarmerByLocation', this.params);
      this.$store.dispatch('getAppActivities', this.params);
      this.$store.dispatch('intermediasiRole', this.params);
      this.$store.dispatch('intermediasiLocation', this.params);
      this.$store.dispatch('intermediasiGender', this.params);
    }
  }
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.dashboard-editor-container {
  padding: 32px;
  .header-filter {
    h2 {
      font-size: 32px;
      color: #086939;
    }
    .link-right {
      font-size: 16px;
      color: #086939;
      font-weight: bold;
      float: right;
      span {
        margin-right: 9px;
      }
      .bigger.svg-icon {
        width: 23px;
        height: 23px;
        margin-bottom: -5px;
      }
    }
  }
  .el-row--shaded {
    @include ritx-box;
  }
  .chart-wrapper {
    background: #fff;
    padding: 16px;
    height: 384px;
    margin-bottom: 30px;
    @include ritx-box;

    &.\-\-auto {
      height: auto;
    }
  }
  .commodity-container {
    display: flex;
  }
}

hr.overflow {
  margin-left: -15px;
  margin-right: -15px;
}
</style>
